% generate outputs from evaluations based on random selections.
% data generated by fly_eval_selections.m and stored in randsampleres.mat
%
% (C) P. Sykacek 2010

addpath('../mlablib/');

% old paths
%addpath('~/sciwrk/mlbsrc/resultfltr/');    
%addpath('~/sciwrk/mlbsrc/helpers/');

load randsampleres

templeg={'47', '49', '50a', '50b', '51', '52', '54', '56'};

% protdata(tct).allhs=zeros(4, 100);
% protdata(tct).allsignone=zeros(4, 100);
% protdata(tct).allsigbonf=zeros(4, 100);
% protdata(tct).allsigfdr=zeros(4, 100);
%subs(1).name='Random selection of 500 genes per 20 \% channel amplitude quantil.';
%subs(2).name='Random selection of 500 genes per 20 \% channel log ratio quantil.';
%subs(3).name='Selection of a random number of genes per 20 \% channel amplitude quantil.';
%subs(4).name='Selection of a random number of genes per 20 \% channel log ratio quantil.';

sortorder='descend';
plot_info.width=0.3;
plot_info.mrksz=1;
plot_info.linesz=1;
plot_info.txtsz=14;
plot_info.ttlsz=18;
% first investigate the rank preservation in dependancy of different
% (subsampled) data every column in allhs allsignone etc. points to the
% same subset used for evaluating different temperatures.

mygray=gray;
selrows=find(mygray(:,1)>0.5);
mygray=mygray(selrows,:);

%if 0
figure
ssm=1; % sub sampling method
% collect data
allhs=zeros(length(protdata), 100);
allsignone=allhs;
for n=1:100
    for tdx=1:length(protdata)
        allhs(tdx, n)=protdata(tdx).allhs(ssm,n);
        allsignone(tdx, n)=protdata(tdx).allsignone(ssm,n);
    end
end
% generate plots illustrating the order preservation in ranking w.r.t. log likelihoods
[rankprc]=vals2rankprobs(allhs, sortorder);
npos=size(rankprc, 1);
for cp=1:npos
    subplot(2,4,cp);
    [myhandles]=pie(rankprc(cp,:), templeg);
    colormap([1 1 1; 1 1 1]);
    title(sprintf('Rank Position %1.0f', cp), 'FontSize', plot_info.ttlsz);
    nhdls=length(myhandles);
    for j=1:nhdls
        prop=set(myhandles(j));
        if isfield(prop, 'MarkerSize')
            set(myhandles(j), 'MarkerSize', plot_info.mrksz, 'LineWidth', plot_info.linesz);
        end
        if isfield(prop, 'FontSize')
            set(myhandles(j), 'FontSize', plot_info.txtsz);
        end
    end
end
%print -deps randamp_balancepie.eps

figure
ssm=2; % sub sampling method
% collect data
allhs=zeros(length(protdata), 100);
allsignone=allhs;
for n=1:100
    for tdx=1:length(protdata)
        allhs(tdx, n)=protdata(tdx).allhs(ssm,n);
        allsignone(tdx, n)=protdata(tdx).allsignone(ssm,n);
    end
end
% generate plots illustrating the order preservation in ranking w.r.t. log likelihoods
[rankprc]=vals2rankprobs(allhs, sortorder);
npos=size(rankprc, 1);
for cp=1:npos
    subplot(2,4,cp);
    [myhandles]=pie(rankprc(cp,:), templeg);
    colormap([1 1 1; 1 1 1]);
    title(sprintf('Rank Position %1.0f', cp), 'FontSize', plot_info.ttlsz);
    nhdls=length(myhandles);
    for j=1:nhdls
        prop=set(myhandles(j));
        if isfield(prop, 'MarkerSize')
            set(myhandles(j), 'MarkerSize', plot_info.mrksz, 'LineWidth', plot_info.linesz);
        end
        if isfield(prop, 'FontSize')
            set(myhandles(j), 'FontSize', plot_info.txtsz);
        end
    end
end
%print -deps randrt_balancepie.eps

figure
ssm=3; % sub sampling method
% collect data
allhs=zeros(length(protdata), 100);
allsignone=allhs;
for n=1:100
    for tdx=1:length(protdata)
        allhs(tdx, n)=protdata(tdx).allhs(ssm,n);
        allsignone(tdx, n)=protdata(tdx).allsignone(ssm,n);
    end
end
% generate plots illustrating the order preservation in ranking w.r.t. log likelihoods
[rankprc]=vals2rankprobs(allhs, sortorder);
%rankprc
npos=size(rankprc, 1);
for cp=1:npos
    subplot(2,4,cp);
    rpfrac=rankprc(cp,:);
    idsmll=find((rpfrac<0.05) & (rpfrac > 0));
    if length(idsmll) > 1 % get rid of excessively many small values
        idok=find(rpfrac>=0.05);
        sumsmall=sum(rpfrac(idsmll));
        rpfrac(idsmll)=0;
        rpfrac(idsmll(1))=sumsmall;
        cleg=templeg;
        cleg{idsmll(1)}=mymatpaste(templeg(idsmll));
    else
        cleg=templeg;
    end
    [myhandles]=pie(rpfrac, cleg);
    colormap([1 1 1; 1 1 1]);
    title(sprintf('Rank Position %1.0f', cp), 'FontSize', plot_info.ttlsz);
    nhdls=length(myhandles);
    for j=1:nhdls
        prop=set(myhandles(j));
        if isfield(prop, 'MarkerSize')
            set(myhandles(j), 'MarkerSize', plot_info.mrksz, 'LineWidth', plot_info.linesz);
        end
        if isfield(prop, 'FontSize')
            set(myhandles(j), 'FontSize', plot_info.txtsz);
        end
    end
end
%print -deps randamp_varypie.eps

figure
ssm=4; % sub sampling method
% collect data
allhs=zeros(length(protdata), 100);
allsignone=allhs;
for n=1:100
    for tdx=1:length(protdata)
        allhs(tdx, n)=protdata(tdx).allhs(ssm,n);
        allsignone(tdx, n)=protdata(tdx).allsignone(ssm,n);
    end
end
% generate plots illustrating the order preservation in ranking w.r.t. log likelihoods
[rankprc]=vals2rankprobs(allhs, sortorder);
npos=size(rankprc, 1);
for cp=1:npos
    subplot(2,4,cp);
    rpfrac=rankprc(cp,:);
    [rpfrac, id]=sort(rpfrac);
    srtleg=templeg(id);
    idsmll=find((rpfrac<0.05) & (rpfrac > 0));
    %idsmll=[]
    if length(idsmll) > 1 % get rid of excessively many small values
        idok=find(rpfrac>=0.05);
        sumsmall=sum(rpfrac(idsmll));
        rpfrac(idsmll)=0;
        rpfrac(idsmll(1))=sumsmall;
        cleg=srtleg;
        cleg{idsmll(1)}=mymatpaste(srtleg(idsmll));
    else
        cleg=srtleg;
    end
    xpld=zeros(size(rpfrac));
    xst=1;
    for n=1:length(rpfrac)
        if rpfrac(n)>0
            xpld(n)=xst;
            if xst==0
                xst=1;
            else
                xst=0;
            end
        end
    end
           
    [myhandles]=pie(rpfrac, xpld, cleg);
    % colormap([1 1 1; 1 1 1]);
    colormap(mygray)
    title(sprintf('Rank Pos. %1.0f', cp), 'FontSize', plot_info.ttlsz);
    nhdls=length(myhandles);
    for j=1:nhdls
        prop=set(myhandles(j));
        if isfield(prop, 'MarkerSize')
            set(myhandles(j), 'MarkerSize', plot_info.mrksz, 'LineWidth', plot_info.linesz);
        end
        if isfield(prop, 'FontSize')
            set(myhandles(j), 'FontSize', plot_info.txtsz);
        end
    end
end
%print -deps fly_randrt_varypie.eps
%end

return
% we now illustrate the correlation between number of significant genes and
% the proposed evaluation methods and study overlap and difference in gene
% sets found at different temperature settings.
pthrs=0.01;
rt_gids_sig={};
amp_gids_sig={};
for tdx=1:length(protdata)
    rt_gids_sig{tdx}=sort([rt_datacolstest(find(protdata(tdx).rt_testpvals<pthrs)), rt_datacolseval(find(protdata(tdx).rt_evalpvals<pthrs))]);
    amp_gids_sig{tdx}=sort([amp_datacolstest(find(protdata(tdx).amp_testpvals<pthrs)), amp_datacolseval(find(protdata(tdx).amp_evalpvals<pthrs))]);
end
allshrd_rt=rt_gids_sig{1};
alldiff_rt=[];
allshrd_amp=amp_gids_sig{1};
alldiff_amp=[];
for tdx=2:length(protdata)
    [allshrd_amp, cd_amp]=compsrtnums(allshrd_amp, amp_gids_sig{tdx});
    alldiff_amp=[alldiff_amp;cd_amp];
    [allshrd_rt, cd_rt]=compsrtnums(allshrd_rt, rt_gids_sig{tdx});
    alldiff_rt=[alldiff_rt;cd_rt];
end
alldiff_amp=unique(alldiff_amp);
alldiff_rt=unique(alldiff_rt);
% we will now analyse the differences between the gene lists at the 0.01
% threshold between temperatures 50 and 51 C:
nsel50=length(rt_gids_sig{4});
gids51=rt_gids_sig{5};
nsel51=length(gids51);
gidadd51=gids51((nsel50+1):nsel51);
% take only those genes above the selection threshold, which are not
% selected by 50
[equal, diff]=compsrtnums(gidadd51, rt_gids_sig{4});
[equal, gidadd51]=compsrtnums(gidadd51, equal);

% get the expression values at 50 which these genes have:
allexpadd_fem=protdata(4).Rdata(:, gidadd51);
allexpadd_mal=protdata(4).Gdata(:, gidadd51);
[equal, gid50diff51]=compsrtnums(rt_gids_sig{4}, rt_gids_sig{5});
allexpdiff_fem=protdata(4).Rdata(:, gid50diff51);
allexpdiff_mal=protdata(4).Gdata(:, gid50diff51);
