function [P]=cdf_stdGauss(x)
% function [P]=cdf_stdGauss(x)
% cumulative distribution function of Gaussian distribution 
% with zero mean and unit std. deviation.
%
% (C) P. Sykacek 2003

erfin=-x./sqrt(2);
P=0.5*erfc(erfin);
idz=find(P<=0);
P(idz)=eps;
ido=find(P>=1);
P(ido)=1-eps;
