function [Ez]=em_EQz(mz, std_z, in, trg)
% function [Ez]=EQz(mz, std_z, in, trg)
% calculates the expectation of latent z's w.r.t. the truncated Qz distribution
%
% (C) P. Sykacek 2004

Ez=mz;
Ez=Ez(:);
idone=find(trg==1);
idzero=find(trg==0);
arg_one=-Ez(idone)/std_z;
arg_zero=-Ez(idzero)/std_z;
%pdf_stdGauss(arg_one)
div_one=(1-cdf_stdGauss(arg_one));
div_one(div_one<=0)=10^-19;
Ez(idone)=Ez(idone)+std_z*pdf_stdGauss(arg_one)./div_one;
div_zero=cdf_stdGauss(arg_zero);
div_zero(div_zero<=0)=10^-19;
Ez(idzero)=Ez(idzero)-std_z*pdf_stdGauss(arg_zero)./div_zero;
if any(~isfinite(Ez))
    'mz'
    mz(~isfinite(Ez))
    arg_one(~isfinite(Ez(idone)))
    arg_zero(~isfinite(Ez(idzero)))
    'Ez'
    Ez(~isfinite(Ez))
    
    1-cdf_stdGauss(arg_one(~isfinite(Ez(idone))))
    pdf_stdGauss(arg_one(~isfinite(Ez(idone))))
    cdf_stdGauss(arg_zero(~isfinite(Ez(idzero))))
    pdf_stdGauss(arg_zero(~isfinite(Ez(idzero))))
end
