function [m, P, C]=em_Qw(in, Ez, lambda, prec)
% function [m, P, C]=Qw(in, Ez, lambda, prec) maximizes
% expected log likelihood w.r.t. w, where w are the generalized 
% linear model parameters.
% IN: 
% in, Ez - inputs and expected latent variables
% lambda - precision of prior over GLM parameters
% prec   - precision of latent variable Gaussian (p(z| x'*w, prec))
%
% (C) P.S. 2004, 2005

if nargin == 2 % then we have a ML solution
    lambda=0;
    prec=1;
end
nin=size(in,2);
if prod(size(lambda))==1
    L=eye(nin)*lambda;
else
    L=lambda;
end
nsampe=size(in, 1);
P=L+prec*in'*in;
C=pinv(P);
m=C*prec*sum(in'.*Ez(:, ones(1, nin))', 2);
%if any(~isfinite(m))
%    in
%    Ez
%    lambda
%    prec
%end