function [catstr]=mymatpaste(cellstr, catsym)
% function [catstr]=mymatpaste(cellstr, catsym) concatenates the strings in
% cellstr using the symbol catsym as separtor.
%
% IN
% cellstr:    a cell array of strings
% catsym:     a optional concatenator symbol. default ', ' (comma and
%             blank)
% OUT
% catstr:     string containing the concatenated cellstr.
%
% (C) P. Sykacek 2008 <peter@sykacek.net>

if nargin < 2
    catsym=', ';
end

catstr='';
nstrs=length(cellstr);
for n=1:nstrs-1
    catstr=[catstr, cellstr{n}, catsym];
end
catstr=[catstr, cellstr{nstrs}];

